﻿var PartsScriptsInitialized = false;

/* Report Part name is case sensitive */
function CapitaliseString(string) {
	if (string == null)
		return '';
	string = string.toLowerCase();
	return string.charAt(0).toUpperCase() + string.slice(1);
}

function GerReportPartUrl(rn, part, first, params) {
	var url = '';
	if (part != '')
		url = resposeServerUrl + '?wscmd=renderedreportpart&wsarg0=' + rn + "&wsarg1=" + part;
	else
		url = resposeServerUrl + '?wscmd=renderedreportpart&wsarg0=' + rn;

	if (!first)
		url += '&wsarg2=alonenext';

	if (params != null)
		url += '&' + params;

	return url;
}

function LoadReportPart(div, first, params) {
	jq$(div).text('Loading...');
	var rn = jq$(div).data('report');
	var part = CapitaliseString(jq$(div).data('part'));
	jq$.ajax({
		url: GerReportPartUrl(rn, part, first, params),
		cache: false
	}).done(function (html) {
		if (first) {
			var headIdx = html.indexOf('</head>');
			if (headIdx > 0)
				html = html.slice(0, headIdx) + '<script type="text/javascript">PartsScriptsInitialized = true;</script>' + html.slice(headIdx);
		}
		UpdateReportPartContainer(div, html, first);
	});
}

function UpdateReportPartContainer(div, html, first) {
	if (first || (typeof(PartsScriptsInitialized) != 'undefined' && PartsScriptsInitialized))
		jq$(div).html(html);
	else
		setTimeout(function () { { UpdateReportPartContainer(div, html); } }, 500);
}

function InitializeReportParts() {
	if (typeof (resposeServerUrl) == 'undefined')
		return;
	var reportParts = jq$('.report-part');
	reportParts.each(function (idx) {
		LoadReportPart(this, idx == 0);
	});
}

jq$(window).load(function () {
	InitializeReportParts();
});

/* Report Viewer override */
function GetRenderedReportSet(invalidateInCache, additionalParams, caller) {
	var reportPart = jq$(caller).closest('.report-part');
	if (reportPart != null)
		LoadReportPart(reportPart, false, additionalParams);
}